from src.aws.s3 import BackupBucket, DataBucket
from src.config.objects import TargetObject
from src.error.exceptions import FileUploadException
from src.system_var.constants import UPLD_JP_NAME
from src.system_var.environments import CRM_IMPORT_DATA_BACKUP_FOLDER
from src.util.execute_datetime import ExecuteDateTime
from src.util.logger import logger_instance as logger


def copy_crm_csv_data_process(target_object: TargetObject, execute_datetime: ExecuteDateTime):
    """CSVアップロード処理

    Args:
        target_object (TargetObject): 取得対象オブジェクト情報インスタンス
        execute_datetime (ExecuteDateTime): 実行日時取得インスタンス

    Raises:
        FileUploadException: S3のファイルアップロード失敗
    """

    # ① CSVデータアップロード処理の開始ログを出力する
    target_object_name = target_object.object_name
    upload_file_name = target_object.upload_file_name

    logger.info(
        f'I-UPLD-01 [{target_object_name}] のCSVデータアップロード処理を開始します ファイル名：[{upload_file_name}.csv]')

    try:
        # ② CRMバックアップ保管用バケットに保管した変換後のCSVデータをデータ取込バケットにコピーする
        data_bucket = DataBucket()
        backup_bucket = BackupBucket()
        data_bucket.put_csv_from(str(backup_bucket), f'{CRM_IMPORT_DATA_BACKUP_FOLDER}/{execute_datetime.to_path()}/{upload_file_name}.csv')

        logger.debug(
            f'D-UPLD-02 [{target_object_name}] のCSVデータアップロード 正常終了')

    except Exception as e:
        raise FileUploadException(
            'E-UPLD-01', UPLD_JP_NAME, f'[{target_object_name}] CSVデータのアップロードに失敗しました ファイル名：[{upload_file_name}.csv] エラー内容:[{e}]')

    # ③ CSVデータアップロード処理の終了ログを出力する
    logger.info(
        f'I-UPLD-03 [{target_object_name}] のCSVデータのアップロード処理を終了します')

    # ④ 次の処理へ移行する
    return
